package implementation;

import java.io.File;

// see ../mdw2021/IPuzzle.java for comments about implementation of functions below
import mdw2021.IPuzzle;

public class Puzzle implements IPuzzle {

	private PuzzleSolver solver;
	private boolean hasSolution;

	public Puzzle() {
		this.hasSolution = false;
	}

	public void readInput(String filename) {
		solver = PuzzleSolver.parseInput(new File(filename));
	}

	public void solve() {
		hasSolution = solver.solve();
	}

	public boolean hasSolution() {
		return hasSolution;
	}

	public void writeResult(String filename) {
		solver.writeSolutionTo(new File(filename));
	}

}
