package implementation;

import java.util.ArrayList;

public class QuaderType {
    private Quader representative;
    private ArrayList<Integer> partNumbers = new ArrayList<>();
    private int occurrences;

    public QuaderType(Quader representative, ArrayList<Integer> partNumbers, int occurrences){
        this.occurrences = occurrences;
        
        if(partNumbers == null){
            this.partNumbers = new ArrayList<>();
        }else{
            this.partNumbers = partNumbers;
        }
        
        this.representative = representative;
    }

    public boolean equals(Object e){
        if(e instanceof QuaderType){
            QuaderType type = (QuaderType) e;
            return partNumbers.equals(type.partNumbers) && occurrences == type.occurrences && representative.equals(type.representative);
        }else{
            return false;
        }
    }

    public QuaderType clone(){
        return new QuaderType(this.representative.clone(), (ArrayList<Integer>) partNumbers.clone(), occurrences);
    }

    public void addPartNumber(int number){
        partNumbers.add(number);
    }

    public ArrayList<Integer> getPartNumbers(){
        return this.partNumbers;
    }

    public void addOccurence(){
        occurrences += 1;
    }

    public void subtractOccurance(){
        occurrences -= 1;
        if(occurrences < 0){
            System.out.println("Fehler!");
        }
    }

    public int getNumberOfOccurrences(){
        return occurrences;
    }

}